/*  Project mec2suf
    Project Team DoGA
    Copyright (c) 1996. All Rights Reserved.

    TuVXe:    mec2suf.exe Application
    t@C:        mc2sfabd.cpp
    쐬:          Masamichi Takatsu


    Tv
    ====
    mec2sufAboutDlg (TDialog) ̃Cve[Vp̃\[Xt@C
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\static.h>

#if !defined(__FLAT__)
#include <ver.h>
#endif

#include "mc2sfapp.h"
#include "mc2sfabd.h"


ProjectRCVersion::ProjectRCVersion (TModule *module)
{
    char    appFName[255];
    char    subBlockName[255];
    DWORD   fvHandle;
    UINT    vSize;

    FVData = 0;

    module->GetModuleFileName(appFName, sizeof(appFName));
    DWORD dwSize = GetFileVersionInfoSize(appFName, &fvHandle);
    if (dwSize) {
        FVData  = (void FAR *)new char[(UINT)dwSize];
        if (GetFileVersionInfo(appFName, fvHandle, dwSize, FVData)) {
            // obt@ɃRs[鎖ɂCWin16  -dc RpCXCb`(萔R[h
            // ZOgɓƂ)w肵ꍇłCVerQueryValue ܂삷悤ɂB
            // ́CMicrosoft  ver.dll  subBlockName Ŏ镶ɏ݂Ă܂Ƃ
            // ɑΏ邽߂̂̂ł
            lstrcpy(subBlockName, "\\VarFileInfo\\Translation"); 
            if (!VerQueryValue(FVData, subBlockName, (void FAR* FAR*)&TransBlock, &vSize)) {
                delete FVData;
                FVData = 0;
            } else
                // ㉺[hXbvāCwsprintf  lang-charset 𐳂ŏo͂悤ɂ
                *(DWORD *)TransBlock = MAKELONG(HIWORD(*(DWORD *)TransBlock), LOWORD(*(DWORD *)TransBlock));
        }
    }
}


ProjectRCVersion::~ProjectRCVersion ()
{
    if (FVData)
        delete FVData;
}


BOOL ProjectRCVersion::GetProductName (LPSTR &prodName)
{
    UINT    vSize;
    char    subBlockName[255];

    wsprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(DWORD *)TransBlock, (LPSTR)"ProductName");
    return FVData ? VerQueryValue(FVData, subBlockName, (void FAR* FAR*)&prodName, &vSize) : FALSE;
}


BOOL ProjectRCVersion::GetProductVersion (LPSTR &prodVersion)
{
    UINT    vSize;
    char    subBlockName[255];

    wsprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(DWORD *)TransBlock, (LPSTR)"ProductVersion");
    return FVData ? VerQueryValue(FVData, subBlockName, (void FAR* FAR*)&prodVersion, &vSize) : FALSE;
}


BOOL ProjectRCVersion::GetCopyright (LPSTR &copyright)
{
    UINT    vSize;
    char    subBlockName[255];

    wsprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(DWORD *)TransBlock, (LPSTR)"LegalCopyright");
    return FVData ? VerQueryValue(FVData, subBlockName, (void FAR* FAR*)&copyright, &vSize) : FALSE;
}


BOOL ProjectRCVersion::GetDebug (LPSTR &debug)
{
    UINT    vSize;
    char    subBlockName[255];

    wsprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(DWORD *)TransBlock, (LPSTR)"SpecialBuild");
    return FVData ? VerQueryValue(FVData, subBlockName, (void FAR* FAR*)&debug, &vSize) : FALSE;
}


//{{mec2sufAboutDlg Implementation}}


//////////////////////////////////////////////////////////
// mec2sufAboutDlg
// ==========
// \z / j󎞂̏
mec2sufAboutDlg::mec2sufAboutDlg (TWindow *parent, TResId resId, TModule *module)
    : TDialog(parent, resId, module)
{
    // INSERT>> RXgN^p̃R[h͂
}


mec2sufAboutDlg::~mec2sufAboutDlg ()
{
    Destroy();

    // INSERT>> fXgN^p̃R[h͂
}


void mec2sufAboutDlg::SetupWindow ()
{
    LPSTR prodName = 0, prodVersion = 0, copyright = 0, debug = 0;

    // VERSIONINFO ɊÂlCX^eBbNRg[̃eLXg擾
    TStatic *versionCtrl = new TStatic(this, IDC_VERSION, 255);
    TStatic *copyrightCtrl = new TStatic(this, IDC_COPYRIGHT, 255);
    TStatic *debugCtrl = new TStatic(this, IDC_DEBUG, 255);

    TDialog::SetupWindow();

    // VERSIONINFO ̏
    ProjectRCVersion applVersion(GetModule());

    // iEĩo[W擾
    if (applVersion.GetProductName(prodName) && applVersion.GetProductVersion(prodVersion)) {
    // IDC_VERSION ͐iƃo[WԍłCIDC_VERSION ̏l
    // Version ƂP(ǂ̌ɂĂ)CiCVERSIONCio[Wł
        char    buffer[255];
        char    versionName[128];

        buffer[0] = '\0';
        versionName[0] = '\0';

        versionCtrl->GetText(versionName, sizeof(versionName));
        wsprintf(buffer, "%s %s %s", prodName, versionName, prodVersion);

        versionCtrl->SetText(buffer);
    }

    //@IȃRs[Cg擾
    if (applVersion.GetCopyright(copyright))
        copyrightCtrl->SetText(copyright);

    //  VERSIONINFO \[X݂ȂCSpecialBuild eLXg擾
    if (applVersion.GetDebug(debug))
        debugCtrl->SetText(debug);
}
